# Internal Transfer

## Get Transfer Data

<mark style="color:blue;">`GET`</mark> `‎https://<domain>/<api prefix>/<version>/user/internal-wallet/transfer/`

This API endpoint will return destination wallets with transfer charge data.

#### Query Parameters

| Name           | Type   | Description                  |
| -------------- | ------ | ---------------------------- |
| source\_wallet | string | wallet key, defaule: wallet1 |

#### Headers

| Name                                            | Type   | Description         |
| ----------------------------------------------- | ------ | ------------------- |
| apikey<mark style="color:red;">\*</mark>        | string | Apikey              |
| Authorization<mark style="color:red;">\*</mark> | string | Bearer access token |

{% tabs %}
{% tab title="200 " %}

```markup
HTTP/1.1 200 OK
Content-Type: application/json

Body:
{
    "status_code": 200,
    "errors": {},
    "data": {
        "destination_wallets": [
            {
                "destination_wallet": "<wallet_key>",
                "destination_wallet_name": "<wallet_name>",
                "wallet_balance": <wallet_balance>,
                "transfer_charges": {
                    "transfer_charge": "<transfer_charge>",
                    "max_transfer_amount": "<max_transfer_amount>",
                    "min_transfer_amount": "<min_transfer_amount>",
                    "transfer_charge_type": "<transfer_charge_type>"
                }
            },
            ...
        ],
        "currency_data": {
            "decimals": <decimals>,
            "symbol_placement": "<symbol_placement>",
            "symbol": "<currency_symbol>",
            "rate": <currency_rate>
        }
    }
}
```

{% endtab %}
{% endtabs %}

#### Sample Code

**Node**

```javascript
var request = require('request');
var options = {
  'method': 'GET',
  'url': 'https://<domain>/<api prefix>/<version>/user/internal-wallet/transfer/',
  'headers': {
    'apikey': '<apikey>',
    'Authorization': 'Bearer <access token>',
  },
  formData: {}
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});

```

**PHP**

```php
<?php

$curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://<domain>/<api prefix>/<version>/user/internal-wallet/transfer/',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
  CURLOPT_HTTPHEADER => array(
    'apikey: <apikey>',
    'Authorization: Bearer <access token>',
  ),
));

$response = curl_exec($curl);

curl_close($curl);
echo $response;
```

#### Error Responses

| <p>Status Code<br></p> | Error Type       | FIeld          | Description                                                                                                                      |
| ---------------------- | ---------------- | -------------- | -------------------------------------------------------------------------------------------------------------------------------- |
| 400                    | Validation Error | source\_wallet | <p>Internal transactions are disabled for this wallet, Please contact your administrator.</p><p>No destination wallet found.</p> |
| 401                    | Request Failed   |                | Internal transactions are disabled, Please contact your administrator.                                                           |

## Internal Transfer

<mark style="color:green;">`POST`</mark> `‎https://<domain>/<api prefix>/<version>/user/internal-wallet/transfer/`

This API endpoint will perform an internal wallet transfer.

#### Headers

| Name                                            | Type   | Description         |
| ----------------------------------------------- | ------ | ------------------- |
| apikey<mark style="color:red;">\*</mark>        | string | Apikey              |
| Authorization<mark style="color:red;">\*</mark> | string | Bearer access token |

#### Request Body

| Name                   | Type   | Description            |
| ---------------------- | ------ | ---------------------- |
| source\_wallet         | string | source wallet key      |
| destination\_wallet    | string | destination wallet key |
| transfer\_amount       | string | transfer amount        |
| form\_key              | string | form key               |
| token\_checksum\_field | string | token checksum         |
| token\_field           | string | token                  |

{% tabs %}
{% tab title="200 " %}

```markup
HTTP/1.1 200 OK
Content-Type: application/json

Body:
{
    "status_code": 200,
    "errors": {},
    "data": {}
}
```

{% endtab %}
{% endtabs %}

#### Sample Code

**Node**

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': 'https://<domain>/<api prefix>/<version>/user/internal-wallet/transfer/',
  'headers': {
    'apikey': '<apikey>',
    'Authorization': 'Bearer <access token>',
  },
  formData: {
    'source_wallet': '<source_wallet>',
    'destination_wallet': '<destination_wallet>',
    'transfer_amount': '<transfer_amount>',
    'form_key': '<form_key>',
    'token_checksum_field': '<token_checksum>',
    'token_field': '<token>'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

**PHP**

```php
<?php

$curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://<domain>/<api prefix>/<version>/user/internal-wallet/transfer/',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS => array('source_wallet' => '<source_wallet>','destination_wallet' => '<destination_wallet>','transfer_amount' => '<transfer_amount>','form_key' => '<form_key>','token_checksum_field' => '<token_checksum>','token_field' => '<token>'),
  CURLOPT_HTTPHEADER => array(
    'apikey: <apikey>',
    'Authorization: Bearer <access token>',
  ),
));

$response = curl_exec($curl);

curl_close($curl);
echo $response;
```

#### Error Responses

| Status Code | Error Type       | FIeld                  | Description                                                                                                                                                                                                                                                                                                                         |
| ----------- | ---------------- | ---------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| 400         | Validation Error | source\_wallet         | <p>This field is required.</p><p>This field may not be blank.</p><p>Internal transactions are disabled for this wallet, Please contact your administrator or invalid source wallet.</p>                                                                                                                                             |
| 400         | Validation Error | destination\_wallet    | <p>This field is required.</p><p>This field may not be blank.</p><p>Invalid destination wallet choosen.</p>                                                                                                                                                                                                                         |
| 400         | Validation Error | transfer\_amount       | <p>This field is required.</p><p>This field may not be blank.</p><p>Transaction Limit is \<max\_amount>.</p><p>Minimum transaction amount is \<min\_amount>.</p><p>Only integers are allowed.</p><p>Ensure this field has no more than 7 characters.</p><p>Entered amount is greater than wallet balance.</p><p>Invalid amount.</p> |
| 400         | Validation Error | form\_key              | <p>This field is required.</p><p>This field may not be blank.</p><p>You have another form running, Please reload.</p>                                                                                                                                                                                                               |
| 400         | Validation Error | token\_checksum\_field | <p>This field is required.</p><p>This field may not be blank.</p>                                                                                                                                                                                                                                                                   |
| 400         | Validation Error | token\_field           | <p>This field is required.</p><p>This field may not be blank.</p><p>Token is not matching.</p><p>Only numeric characters are allowed.</p>                                                                                                                                                                                           |
| 401         | Request Failed   |                        | <p>Some errors occured.</p><p>Internal transactions are disabled, Please contact your administrator.</p><p>No destination wallets found for this source wallet.</p>                                                                                                                                                                 |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://api.epixelsoftware.help/internal-transfer.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
